@echo off
@echo.
@echo ==========================================================================
set SWNAME=fit_srtm
@echo Test procedures for %SWNAME%
@echo ==========================================================================
@echo.
@echo Checking that we have all datafiles that we need for testing 
if not exist rpplasma.kbq goto FAILED
if not exist frames1.dat goto FAILED
if not exist frames1_smallgap.dat goto FAILED
if not exist frames1_biggap.dat goto FAILED
if not exist frames1_smalloverlap.dat goto FAILED
if not exist frames1_bigoverlap.dat goto FAILED
if not exist frames1_few.dat goto FAILED
if not exist frames2.dat goto FAILED
@echo passed.
dft2svg rpplasma.svg -l rpplasma.kbq
@echo And that we have the executable to test
if not exist ..\%SWNAME%.exe goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo Simulating data for comparison, if it does not exist already
@echo.

if not exist rpsim.dft goto DO_RPSIM 
if not exist rpsim_smallgap.dft goto DO_RPSIM 
if not exist rpsim_biggap.dft goto DO_RPSIM 
if not exist rpsim_smalloverlap.dft goto DO_RPSIM 
if not exist rpsim_bigoverlap.dft goto DO_RPSIM 
if not exist rpsim_fewframes.dft goto DO_RPSIM 
goto RPSIM_READY
:DO_RPSIM
p2t_3c -nosub --silent rpplasma.kbq 0.11  0.35  0 0 0 0 cer1.dft
p2t_3c -nosub --silent rpplasma.kbq 0.153 0.489 0.303 0.0926 0 0 tis1.dft
p2t_3c -nosub --silent rpplasma.kbq 0.153 0.489 0.303 0.1852 0 0 tis2.dft
if not %errorlevel%==0 goto FAILED
dftadd --silent -ovr temp.dft cer1.dft
dftadd --silent temp.dft tis1.dft
dftadd --silent temp.dft tis2.dft
del tis?.dft
dftrenpl --silent temp.dft
dftren --silent temp.dft 1 cereb . all
dftren --silent temp.dft 2 putam d all
dftren --silent temp.dft 3 putam s all
dftstudy temp.dft rpsim1
fr4sim --silent temp.dft frames1.dat rpsim.dft C-11
if not %errorlevel%==0 goto FAILED
dftweigh_2_2_2 rpsim.dft
if not %errorlevel%==0 goto FAILED
REM gaps
fr4sim --silent temp.dft frames1_smallgap.dat rpsim_smallgap.dft C-11
if not %errorlevel%==0 goto FAILED
dftweigh_2_2_2 rpsim_smallgap.dft
if not %errorlevel%==0 goto FAILED
fr4sim --silent temp.dft frames1_biggap.dat rpsim_biggap.dft C-11
if not %errorlevel%==0 goto FAILED
dftweigh_2_2_2 rpsim_biggap.dft
if not %errorlevel%==0 goto FAILED
REM overlaps
fr4sim --silent temp.dft frames1_smalloverlap.dat rpsim_smalloverlap.dft C-11
if not %errorlevel%==0 goto FAILED
dftweigh_2_2_2 rpsim_smalloverlap.dft
if not %errorlevel%==0 goto FAILED
fr4sim --silent temp.dft frames1_bigoverlap.dat rpsim_bigoverlap.dft C-11
if not %errorlevel%==0 goto FAILED
dftweigh_2_2_2 rpsim_bigoverlap.dft
if not %errorlevel%==0 goto FAILED
REM few frames
fr4sim --silent temp.dft frames1_few.dat rpsim_fewframes.dft C-11
if not %errorlevel%==0 goto FAILED
dftweigh_2_2_2 rpsim_fewframes.dft
if not %errorlevel%==0 goto FAILED
:RPSIM_READY

if exist basicsim.dft goto BASICSIM_READY
p2t_3c -nosub --silent rpplasma.kbq  0.100 0.200     0 0 0 0 ref1.dft
p2t_3c -nosub --silent rpplasma.kbq  0.400 0.800     0 0 0 0 ref2.dft
p2t_3c -nosub --silent rpplasma.kbq  0.200 0.333333  0 0 0 0 tis3.dft
p2t_3c -nosub --silent rpplasma.kbq  0.200 0.133333  0 0 0 0 tis4.dft
p2t_3c -nosub --silent rpplasma.kbq  0.200 0.036364  0 0 0 0 tis5.dft
p2t_3c -nosub --silent rpplasma.kbq  0.200 0.007843  0 0 0 0 tis6.dft
p2t_3c -nosub --silent rpplasma.kbq  0.050 0.02      0 0 0 0 tis7.dft
p2t_3c -nosub --silent rpplasma.kbq  0.100 0.04      0 0 0 0 tis8.dft
p2t_3c -nosub --silent rpplasma.kbq  0.300 0.12      0 0 0 0 tis9.dft
if not %errorlevel%==0 goto FAILED
dftadd --silent -ovr temp.dft ref1.dft
dftadd --silent temp.dft ref2.dft
dftadd --silent temp.dft tis3.dft
dftadd --silent temp.dft tis4.dft
dftadd --silent temp.dft tis5.dft
dftadd --silent temp.dft tis6.dft
dftadd --silent temp.dft tis7.dft
dftadd --silent temp.dft tis8.dft
dftadd --silent temp.dft tis9.dft
del tis?.dft
fr4sim --silent temp.dft frames2.dat basicsim.dft C-11
if not %errorlevel%==0 goto FAILED
::dftrenpl --silent basicsim.dft
dftren --silent basicsim.dft 1 refer lowk .
dftren --silent basicsim.dft 2 refer highk .
dftren --silent basicsim.dft 3 tis3 . .
dftren --silent basicsim.dft 4 tis4 . .
dftren --silent basicsim.dft 5 tis5 . .
dftren --silent basicsim.dft 6 tis6 . .
dftren --silent basicsim.dft 7 tis7 . .
dftren --silent basicsim.dft 8 tis8 . .
dftren --silent basicsim.dft 9 tis9 . .
if not %errorlevel%==0 goto FAILED
dftweigh basicsim.dft
if not %errorlevel%==0 goto FAILED
dftstudy basicsim.dft sim1
:BASICSIM_READY

if exist nonphyssim.dft goto NONPHYSSIM_READY
p2t_3c -nosub --silent rpplasma.kbq  0.2      0.4       0 0 0 0 ref1.dft
p2t_3c -nosub --silent rpplasma.kbq  0.2      4E-07     0 0 0 0 tis2.dft
p2t_3c -nosub --silent rpplasma.kbq  0.000001 3.33E-07  0 0 0 0 tis3.dft
p2t_3c -nosub --silent rpplasma.kbq  0.2      0.2       0 0 0 0 tis4.dft
if not %errorlevel%==0 goto FAILED
dftadd --silent -ovr temp.dft ref1.dft
dftadd --silent temp.dft tis2.dft
dftadd --silent temp.dft tis3.dft
dftadd --silent temp.dft tis4.dft
del tis?.dft
fr4sim --silent temp.dft frames2.dat nonphyssim.dft C-11
if not %errorlevel%==0 goto FAILED
::dftrenpl --silent nonphyssim.dft
dftren --silent nonphyssim.dft 1 refer . .
dftren --silent nonphyssim.dft 2 irrev . .
dftren --silent nonphyssim.dft 3 noflow . .
dftren --silent nonphyssim.dft 4 fine . .
if not %errorlevel%==0 goto FAILED
dftstudy nonphyssim.dft sim1
:NONPHYSSIM_READY
@echo.
@echo ========================================================================
@echo.
@echo ========================================================================
@echo 1.1.1: No command line options or arguments. Error with user info.
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% > stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt "See also"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "Keywords"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ========================================================================
@echo.
@echo ========================================================================
@echo 1.1.2: Unknown option.
if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% -stupidoption rpsim.dft cereb 60 srtm.res 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stderr.txt Error "invalid option '-stupidoption'."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ========================================================================
@echo 1.1.3: Extra argument.
if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% rpsim.dft cereb 60 srtm.res extra 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stderr.txt Error "too many arguments: 'extra'."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo 1.1.4: Any argument is missing
if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% cereb 60 srtm.res 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% rpsim.dft 60 srtm.res 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% rpsim.dft cereb srtm.res 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% rpsim.dft cereb 60  2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo 1.1.5: Checking that default values of variables that user can set are correct
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 stdout.txt SILENT "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt VERBOSE "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 stdout.txt doDVR "0"
if not %errorlevel%==0 goto FAILED
@echo passed.

iftisval_1_0_2 stdout.txt doCL "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt doSD "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt doBootstrap "0"
if not %errorlevel%==0 goto FAILED
@echo passed.

iftisval_1_0_2 stdout.txt dftfile "rpsim.dft"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt reffile "cereb"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt resfile "srtm.res"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt required_fitdur "60"
if not %errorlevel%==0 goto FAILED
@echo passed.

iftisval_1_0_2 stdout.txt fitfile ""
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt svgfile ""
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt limfile ""
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 1.2.1: options -h and --help print user info
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -h rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt "See also"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "Keywords"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% --help > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt "See also"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "Keywords"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ========================================================================
@echo 1.2.2: option --build prints software version info

if exist test.dat del test.dat
echo 0.5 6.0 > test.dat
echo # Correct nr of lines containing Build >> test.dat

if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% --build | grep --count Build > stdout.txt
addtimes stdout.txt
echo # Nr of lines containing Build >> stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
dftmatch_1_1_5 stdout.txt test.dat
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 1.3.1: option --silent
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test --silent rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt SILENT "1"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt VERBOSE "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ========================================================================
@echo 1.3.2: option --verbose
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test --verbose rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt SILENT "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt VERBOSE "1"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ========================================================================
@echo.
@echo ========================================================================
@echo 1.4.1: Options -SD, -SD=y and -SD=n
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -sd rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt doSD "1"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt doCL "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -sd=y rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt doSD "1"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt doCL "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -sd=n rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt doSD "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt doCL "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo 1.4.2: Options -CL, -CL=y and -CL=n
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -CL rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt doSD "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt doCL "1"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -cl=y rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt doSD "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt doCL "1"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -CL=n rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt doSD "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt doCL "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 1.5.1: Option -lim
if exist stdout.txt del stdout.txt
if exist temp.par del temp.par
@echo on
..\%SWNAME% -test -lim=temp.par > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt limfile "temp.par"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

@echo on
..\%SWNAME% -test -lim=
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo on
..\%SWNAME% -test -lim
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 1.6.1: Option -fit
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -fit=fit.dat rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt fitfile "fit.dat"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

@echo on
..\%SWNAME% -test -fit= rpsim.dft cereb 60 srtm.res
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo on
..\%SWNAME% -test -fit rpsim.dft cereb 60 srtm.res
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 1.7.1: Option -svg
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -svg=fit.svg rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt svgfile "fit.svg"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

@echo on
..\%SWNAME% -test -svg= rpsim.dft cereb 60 srtm.res
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo on
..\%SWNAME% -test -svg rpsim.dft cereb 60 srtm.res
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 1.8.1: Option -dvr
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test -DVR rpsim.dft cereb 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt doDVR "1"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 2.1.1: General functionality
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% -svg=basicsim.svg basicsim.dft "refer lowk" 120 srtm.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_4 -abs=0.1 -header=y -param=y -regions=y -res=1 correct_basic1.res srtm.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_4 -abs=0.05 -header=y -param=y -regions=y -res=2 correct_basic1.res srtm.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_4 -abs=0.1 -header=y -param=y -regions=y -res=3 correct_basic1.res srtm.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist srtm2.res del srtm2.res
@echo on
..\%SWNAME% -svg=basicsim.svg basicsim.dft "refer highk" 120 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_4 -abs=0.1 -header=y -param=y -regions=y -res=1 correct_basic2.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_4 -abs=0.05 -header=y -param=y -regions=y -res=2 correct_basic2.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_4 -abs=0.1 -header=y -param=y -regions=y -res=3 correct_basic2.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo 2.1.2: General functionality with nonphysiological data
if exist srtm3.res del srtm3.res
@echo on
..\%SWNAME% -svg=nonphyssim.svg nonphyssim.dft "refer" 120 srtm3.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_4 -abs=0.5 -header=y -param=y -regions=y -res=1 correct_nonphys.res srtm3.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_4 -abs=0.2 -header=y -param=y -regions=y -res=2 correct_nonphys.res srtm3.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_4 -abs=1000000 -header=y -param=y -regions=y -res=3 correct_nonphys.res srtm3.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 2.2.1: General functionality with RP data
if exist rpsim.res del rpsim.res
@echo on
..\%SWNAME% -svg=rpsim.svg rpsim.dft "cereb" 60 rpsim.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_4 -abs=0.4 -header=y -param=y -regions=y -res=1 correct_rpsim.res rpsim.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_4 -abs=0.3 -header=y -param=y -regions=y -res=2 correct_rpsim.res rpsim.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_4 -abs=0.02 -header=y -param=y -regions=y -res=3 correct_rpsim.res rpsim.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.1.1: reference file
if exist tis.dft del tis.dft
copy basicsim.dft tis.dft
dftdel --silent tis.dft refer
dftadd -ovr --silent refer.dft basicsim.dft refer

if exist stdout.txt del stdout.txt
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% tis.dft refer.dft 120 srtm.res 2> stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 srtm.res "Reference region" "refer lowk ."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt "Warning" "several reference regions found: refer lowk . selected."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.1.2: reference name
if exist stdout.txt del stdout.txt
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% basicsim.dft refer 120 srtm.res 2> stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 srtm.res "Reference region" "refer lowk ."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt "Warning" "several reference regions found: refer lowk . selected."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist stdout.txt del stdout.txt
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% basicsim.dft "refer highk" 120 srtm.res 2> stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 srtm.res "Reference region" "refer highk ."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.1.3: reference number

if exist srtm.res del srtm.res
@echo on
..\%SWNAME% basicsim.dft 1 120 srtm.res
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 srtm.res "Reference region" "refer lowk ."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist srtm.res del srtm.res
@echo on
..\%SWNAME% basicsim.dft 2 120 srtm.res
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 srtm.res "Reference region" "refer highk ."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.2.1: non-existing file. Error must be printed.

if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% nonexistingfile.dat "cereb" 60 rpsim.res 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stderr.txt "Error in reading 'nonexistingfile.dat'" "cannot open file"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% rpsim.dft nonexistingfile.dat 60 rpsim.res 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stderr.txt "Error in reading reference input" "cannot find region"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo 3.3.1: Wrong tissue file format. Error must be printed.

if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% ..\%SWNAME%.exe "cereb" 60 rpsim.res 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stderr.txt "Error in reading '..\%SWNAME%.exe'" "unknown file format"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist stderr.txt del stderr.txt
@echo on
..\%SWNAME% rpsim.dft ..\%SWNAME%.exe 60 rpsim.res 2> stderr.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stderr.txt "Error in reading reference input" "unknown file format"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo 3.3.2: File without DFT headers is accepted.
dft2dat basicsim.dft basicsim.dat
if exist srtm1.res del srtm1.res
if exist srtm2.res del srtm2.res
@echo on
..\%SWNAME% basicsim.dft 2 120 srtm1.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo on
..\%SWNAME% basicsim.dat 2 120 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -abs=0.01 -header=n -param=y -regions=n -res=1,2 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_2 -abs=0.05 -header=n -param=y -regions=n -res=3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.4.1: Time gap in the beginning
@echo.
@echo 3 s gap should not even lead to a warning.
dfttime rpsim.dft 0.05 temp.dft
if not %errorlevel%==0 goto FAILED
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% temp.dft cereb 60 srtm.res 2> stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt "Warning"
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.

@echo 6 s gap should lead to a warning.
dfttime rpsim.dft 0.10 temp.dft
if not %errorlevel%==0 goto FAILED
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% temp.dft cereb 60 srtm.res 2> stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt "Warning" "TACs should start at time zero."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

@echo 1 min gap should lead to an error.
dfttime rpsim.dft 1.0 temp.dft
if not %errorlevel%==0 goto FAILED
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% temp.dft cereb 60 srtm.res 2> stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt "Error" "TACs must start at time zero."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.4.2: Time gap/overlap between frames
@echo on
..\%SWNAME% --silent rpsim.dft cereb 60 srtm1.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo.

@echo Small gap should give the same result as without gap
@echo on
..\%SWNAME% rpsim_smallgap.dft cereb 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -abs=0.001 -res=1,2,3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo Larger gap should give about the same result as without gap
@echo on
..\%SWNAME% rpsim_biggap.dft cereb 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -abs=0.01 -res=1,2,3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

@echo Small overlap should give the same result as without gap
@echo on
..\%SWNAME% rpsim_smalloverlap.dft cereb 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -abs=0.001 -res=1,2,3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo Big overlap should lead to an error.
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% rpsim_bigoverlap.dft cereb 60 srtm.res 2> stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt "Error" "rpsim_bigoverlap.dft has overlapping frame times."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.4.3: Reference file middle frame times are replaced by start and end times

if exist tis.dft del tis.dft
copy rpsim_fewframes.dft tis.dft
dftdel tis.dft cereb
dftadd -ovr refer.dft rpsim_fewframes.dft cereb

if exist srtm1.res del srtm1.res
@echo on
..\%SWNAME% tis.dft refer.dft 60 srtm1.res
@echo off
if not %errorlevel%==0 goto FAILED

dft2dat -ift refer.dft refer.dat
if exist srtm2.res del srtm2.res
@echo on
..\%SWNAME% tis.dft refer.dat 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -res=1,2,3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.4.4: Frame lengths are considered in calculations

if exist srtm1.res del srtm1.res
@echo on
..\%SWNAME% rpsim.dft cereb 60 srtm1.res
@echo off
if not %errorlevel%==0 goto FAILED

if exist srtm_fewframes1.res del srtm_fewframes1.res
@echo on
..\%SWNAME% rpsim_fewframes.dft cereb 60 srtm_fewframes1.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -abs=0.1 -res=3 srtm1.res srtm_fewframes1.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

REM without frame start and end times results can be worse
dft2dat rpsim_fewframes.dft rpsim_fewframes.dat
if exist srtm_fewframes2.res del srtm_fewframes2.res
@echo on
..\%SWNAME% rpsim_fewframes.dat 1 60 srtm_fewframes2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -abs=0.2 -res=1,2,3 srtm1.res srtm_fewframes2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.5.1: Reference file calibration unit is different

if exist tis.dft del tis.dft
copy rpsim.dft tis.dft
dftdel tis.dft cereb
dftadd -ovr refer.dft rpsim.dft cereb

dftunit -unit="kBq/mL" tis.dft refer.dft
if exist srtm1.res del srtm1.res
@echo on
..\%SWNAME% tis.dft refer.dft 60 srtm1.res
@echo off
if not %errorlevel%==0 goto FAILED

dftunit -uc="Bq/cc" tis.dft
if exist srtm2.res del srtm2.res
@echo on
..\%SWNAME% tis.dft refer.dft 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -res=1,2,3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

dftunit -uc="kBq/mL" tis.dft
dftunit -uc="Bq/cc" refer.dft
if exist srtm2.res del srtm2.res
@echo on
..\%SWNAME% tis.dft refer.dft 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -res=1,2,3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 3.5.2: Reference file time unit is different

if exist tis.dft del tis.dft
copy rpsim.dft tis.dft
dftdel tis.dft cereb
dftadd -ovr refer.dft rpsim.dft cereb

dftunit -timeunit=min tis.dft refer.dft
dftunit -unit="Bq/cc" tis.dft refer.dft
if exist srtm1.res del srtm1.res
@echo on
..\%SWNAME% tis.dft refer.dft 60 srtm1.res
@echo off
if not %errorlevel%==0 goto FAILED

dftunit -ctimeunit=sec tis.dft
if exist srtm2.res del srtm2.res
@echo on
..\%SWNAME% tis.dft refer.dft 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -res=1,2,3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

dftunit -ctimeunit=min tis.dft
dftunit -ctimeunit=sec refer.dft
if exist srtm2.res del srtm2.res
@echo on
..\%SWNAME% tis.dft refer.dft 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
resmatch_1_1_2 -res=1,2,3 srtm1.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 4.1.1: Fit time is zero
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% rpsim.dft cereb 0 srtm.res 2> stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt "Error" "invalid fit time: '0'."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% rpsim.dft cereb zero srtm.res 2> stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt "Error" "invalid fit time: 'zero'."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 4.1.2: Fit time is large
if exist strm.res del strm.res
@echo on
..\%SWNAME% rpsim.dft cereb 999 srtm.res
@echo off
iftisval_1_0_2 srtm.res "Data range" "0 - 120 min"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 4.2.1: Fit time is shorter than data range
if exist strm.res del strm.res
@echo on
..\%SWNAME% rpsim.dft cereb 30 srtm.res
@echo off
iftisval_1_0_2 srtm.res "Data range" "0 - 30 min"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist strm.res del strm.res
@echo on
..\%SWNAME% rpsim.dft cereb 31 srtm.res
@echo off
iftisval_1_0_2 srtm.res "Data range" "0 - 30 min"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

if exist strm.res del strm.res
@echo on
..\%SWNAME% rpsim.dft cereb 33 srtm.res
@echo off
iftisval_1_0_2 srtm.res "Data range" "0 - 35 min"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 4.3.1: Fit time contains less than 4 frames
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% rpsim_fewframes.dft cereb 20 srtm.res 2> stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
iftisval_1_0_2 stdout.txt "Error" "too few data points for a decent fit."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

@echo on
..\%SWNAME% rpsim_fewframes.dft cereb 30 srtm.res 2> stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 5.1.1: Program can write optional output files
if exist srtm1.res del srtm1.res
if exist srtm2.res del srtm2.res
..\%SWNAME% rpsim.dft cereb 60 srtm1.res
if not %errorlevel%==0 goto FAILED
..\%SWNAME% -fit=test.dft -svg=test.svg basicsim.dft "refer lowk" 60 srtm2.res
if not %errorlevel%==0 goto FAILED

if exist test.dft del test.dft
if exist test.svg del test.svg
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% -fit=test.dft -svg=test.svg rpsim.dft cereb 60 srtm.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
if not exist test.dft goto FAILED
@echo passed.
if not exist test.svg goto FAILED
@echo passed.
if not exist srtm.res goto FAILED
@echo passed.

if exist test.par del test.par
@echo on
..\%SWNAME% -lim=test.par
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
if not exist test.par goto FAILED
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 5.2.1: Program can write overwrite existing output files
if exist test.dft.bak del test.dft.bak
if exist test.svg.bak del test.svg.bak
if exist srtm.res.bak del srtm.res.bak
@echo on
..\%SWNAME% -fit=test.dft -svg=test.svg basicsim.dft "refer lowk" 60 srtm.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
if not exist test.dft.bak goto FAILED
@echo passed.
if not exist test.svg.bak goto FAILED
@echo passed.
if not exist srtm.res.bak goto FAILED
@echo passed.
resmatch_1_1_2 srtm.res srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
resmatch_1_1_2 srtm.res.bak srtm1.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ... even if backup files exist
@echo on
..\%SWNAME% -fit=test.dft -svg=test.svg rpsim.dft "cereb" 60 srtm.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
resmatch_1_1_2 srtm.res srtm1.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
resmatch_1_1_2 srtm.res.bak srtm2.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 5.3.1: Result files are compatible with rescoll
if exist srtm1.res del srtm1.res
if exist srtm2.res del srtm2.res
if exist srtm3.res del srtm3.res
..\%SWNAME% rpsim.dft cereb 30 srtm1.res
if not %errorlevel%==0 goto FAILED
..\%SWNAME% rpsim.dft cereb 45 srtm2.res
if not %errorlevel%==0 goto FAILED
..\%SWNAME% rpsim.dft cereb 60 srtm3.res
if not %errorlevel%==0 goto FAILED

rescoll temp.htm srtm1.res srtm2.res srtm3.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 6.1.1: Default constraints
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -test basicsim.dft "refer lowk" 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.

iftisval_1_0_2 stdout.txt "def_pmin[1]" "0.001"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[1]" "10"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 stdout.txt "def_pmin[2]" "1e-006"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[2]" "10"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 stdout.txt "def_pmin[3]" "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[3]" "60"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 6.2.1: Non-existing parameter constraint file
if exist stdout.txt del stdout.txt
if exist temp.par del temp.par
@echo on
..\%SWNAME% -lim=temp.par basicsim.dft "refer lowk" 60 srtm.res 2> stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "Error in reading 'temp.par'" "cannot open file"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 6.2.2: Default constraints can be written in file
if exist temp.par del temp.par
@echo on
..\%SWNAME% -lim=temp.par
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.

iftisval_1_0_2 temp.par "R1_lower" "0.001"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 temp.par "R1_upper" "10"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 temp.par "k2_lower" "1e-006"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 temp.par "k2_upper" "10"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 temp.par "BP_lower" "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 temp.par "BP_upper" "60"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 6.2.3: Default constraints cannot be written in file, if file exists
if exist stdout.txt del stdout.txt
@echo on
..\%SWNAME% -lim=temp.par 2> stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "Error" "constraint file 'temp.par' exists."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 6.2.4: Constraint file contents is correctly read
if exist temp.par del temp.par
echo R1_lower := 0.9   >  temp.par
echo k2_lower := 0.15  >> temp.par
echo BP_lower := 1.2   >> temp.par
echo R1_upper := 1.5   >> temp.par
echo k2_upper := 0,5   >> temp.par
echo BP_upper := 2.9   >> temp.par
if exist stdout.txt del stdout.txt
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% -test -lim=temp.par rpsim.dft "cereb" 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.

iftisval_1_0_2 stdout.txt "def_pmin[1]" "0.9"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[1]" "1.5"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 stdout.txt "def_pmin[2]" "0.15"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[2]" "0.5"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 stdout.txt "def_pmin[3]" "1.2"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[3]" "2.9"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 6.2.5: Constraint file does not need to contain all parameters
if exist temp.par del temp.par
echo R1_upper := 5   >  temp.par
if exist stdout.txt del stdout.txt
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% -test -lim=temp.par rpsim.dft "cereb" 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.

iftisval_1_0_2 stdout.txt "def_pmin[1]" "0.001"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[1]" "5"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 stdout.txt "def_pmin[2]" "1e-006"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[2]" "10"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

iftisval_1_0_2 stdout.txt "def_pmin[3]" "0"
if not %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "def_pmax[3]" "60"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 6.2.6: Constraint file in wrong format
if exist temp.par del temp.par
echo R1_min := 5   >  temp.par
if exist stdout.txt del stdout.txt
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% -lim=temp.par rpsim.dft "cereb" 60 srtm.res 2> stdout.txt
@echo off
if %errorlevel%==0 goto FAILED
@echo passed.
iftisval_1_0_2 stdout.txt "Error" "invalid parameter constraint file."
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 7.1.1: DVR is calculated
if exist srtm.res del srtm.res
if exist dvr.res del dvr.res
@echo on
..\%SWNAME% basicsim.dft "refer lowk" 120 srtm.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo on
..\%SWNAME% -dvr basicsim.dft "refer lowk" 120 dvr.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.

resmatch_1_1_2 -header=y -param=n -regions=y -res=1,2 srtm.res dvr.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

resmatch_1_1_2 -abs=0.1 -header=y -param=y -regions=y -res=1,2,3 correct_basicdvr.res dvr.res
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 8.1.1: File does not contain weights
if exist srtm.res del srtm.res
if exist stdout.txt del stdout.txt
if exist temp.dft del temp.dft
copy rpsim_fewframes.dft temp.dft
dftweigh -rm temp.dft
@echo on
..\%SWNAME% -test temp.dft "cereb" 60 srtm.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt common_data_weights "1, 1, 1, 1, 1, 1, 1"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo 8.2.1: File contains weights
if exist srtm2.res del srtm2.res
if exist stdout.txt del stdout.txt
dftweigh temp.dft
@echo on
..\%SWNAME% -test temp.dft "cereb" 60 srtm2.res > stdout.txt
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.
iftisval_1_0_2 stdout.txt common_data_weights "0.611556, 0.445971, 0.912035, 1.0181, 1.1714, 1.33833, 1.50261"
if not %errorlevel%==0 goto FAILED
@echo passed.
@echo.

REM with weights the results should be changed at least a little
resmatch_1_1_2 -res=1,2,3 srtm.res srtm2.res
if %errorlevel%==0 goto FAILED
@echo passed.
@echo.
@echo ==========================================================================
@echo.
@echo ==========================================================================
@echo 9.1.1: No SD or CL
if exist stdout.txt del stdout.txt
if exist hits.bat del hits.bat
if exist srtm.res del srtm.res
@echo on
..\%SWNAME% rpsim.dft "cereb" 60 srtm.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
type srtm.res | grep --count SD > stdout.txt
copy helpfile.txt + stdout.txt hits.bat > nul
call hits.bat
echo result := %result%
if not %result% == 0 goto FAILED
@echo passed.
@echo.
del hits.bat
@echo ==========================================================================
@echo 9.2.1: SD
if exist stdout.txt del stdout.txt
if exist hits.bat del hits.bat
if exist srtm2.res del srtm2.res
@echo on
..\%SWNAME% -sd=y rpsim.dft "cereb" 60 srtm2.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
type srtm2.res | grep --count SD > stdout.txt
copy helpfile.txt + stdout.txt hits.bat > nul
call hits.bat
echo result := %result%
if not %result% == 2 goto FAILED
@echo passed.
@echo.
del hits.bat
@echo ==========================================================================
@echo 9.3.1: CL
if exist stdout.txt del stdout.txt
if exist hits.bat del hits.bat
if exist srtm3.res del srtm3.res
@echo on
..\%SWNAME% -cl=y rpsim.dft "cereb" 60 srtm3.res
@echo off
if not %errorlevel%==0 goto FAILED
@echo passed.
type srtm3.res | grep --count CL > stdout.txt
copy helpfile.txt + stdout.txt hits.bat > nul
call hits.bat
echo result := %result%
if not %result% == 4 goto FAILED
@echo passed.
@echo.
del hits.bat
@echo.


:PASSED
@echo.
@echo ==========================================================================
@echo all tests passed.
@echo ==========================================================================
@echo.
goto END

:FAILED
@echo.
@echo test failed.
@echo.

:END


